
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>经典算法题每日演练——第十一题 Bitmap算法 / iVAN</title>

    <meta name="description" content="经典算法题每日演练——第十一题 Bitmap算法      在所有具有性能优化的数据结构中,我想大家使用最多的就是hash表,是的,在具有定位查找上具有O(1)的常量时间,多么的简洁优美, 但是在特定的场合下: ①:对10亿个不重复的整数进行排序. ②:找出10亿个数字中重复的数字. 当然我只有普通的服务器,就算2G的内存吧,在这种场景下,我们该如何更好的挑选数据结构和算法呢?   一:问题分析      这年头,大牛们写的排序算法也就那么几个,首先我们算下放在内存中要多少G: (10亿 * 32)/(1024*1024*1024*8)=3.6">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">经典算法题每日演练——第十一题 Bitmap算法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>     在所有具有性能优化的数据结构中，我想大家使用最多的就是hash表，是的，在具有定位查找上具有O(1)的常量时间，多么的简洁优美，</p>
<p>但是在特定的场合下：</p>
<p>①：对10亿个不重复的整数进行排序。</p>
<p>②：找出10亿个数字中重复的数字。</p>
<p>当然我只有普通的服务器，就算2G的内存吧，在这种场景下，我们该如何更好的挑选数据结构和算法呢？</p>
<p> </p>
<p>一：问题分析</p>
<p>     这年头，大牛们写的排序算法也就那么几个，首先我们算下放在内存中要多少G: (10亿 * 32)/(1024*1024*1024*8)=3.6G，可怜</p>
<p>的2G内存直接爆掉，所以各种神马的数据结构都玩不起来了，当然使用外排序还是可以解决问题的，由于要走IO所以暂时剔除，因为我们</p>
<p>要玩高性能，无望后我们想想可不可以在二进制位上做些手脚？  </p>
<p>比如我要对{1,5,7,2}这四个byte类型的数字做排序，该怎么做呢？我们知道byte是占8个bit位，其实我们可以将数组中的值作为bit位的</p>
<p>key，value用”0，1“来标识该key是否出现过？下面看图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzIxNDc0MS8yMDEyMTIwNjEzMjc0OTEzLnBuZw==.jpg"></p>
<p>从图中我们精彩的看到，我们的数组值都已经作为byte中的key了，最后我只要遍历对应的bit位是否为1就可以了，那么自然就成有序数组了。</p>
<p>可能有人说，我增加一个13怎么办？很简单，一个字节可以存放8个数，那我只要两个byte就可以解决问题了。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzIxNDc0MS8yMDEyMTIwNjEzMjgwOTYzLnBuZw==.jpg"></p>
<p>可以看出我将一个线性的数组变成了一个bit位的二维矩阵，最终我们需要的空间仅仅是:3.6G/32=0.1G即可，要注意的是bitmap排序不</p>
<p>是N的，而是取决于待排序数组中的最大值，在实际应用上关系也不大，比如我开10个线程去读byte数组，那么复杂度为:O(Max/10)。</p>
<p> </p>
<p>二：代码</p>
<p>  我想bitmap的思想大家都清楚了，这一次又让我们见证了二进制的魅力，当然这些移位都是位运算的工作了，熟悉了你就玩转了。</p>
<p>1:Clear方法（将数组的所有bit位置0）</p>
<p>   比如要将当前4对应的bit位置0的话，只需要1左移4位取反与B[0] &amp; 即可。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzIxNDc0MS8yMDEyMTIwNjEyNDMwNDExLnBuZw==.jpg"></p>
<pre><code>#region 初始化所用的bit位为0
        /// &lt;summary&gt;
        /// 初始化所用的bit位为0
        /// &lt;/summary&gt;
        /// &lt;param name="i"&gt;&lt;/param&gt;
        static void Clear(byte i)
        {
            //相当于 i%8 的功能
            var shift = i &amp; 0x07;

            //计算应该放数组的下标
            var arrindex = i &gt;&gt; 3;

            //则将当前byte中的指定bit位取0，&amp;后其他对方数组bit位必然不变，这就是 1 的妙用
            var bitPos = ~(1 &lt;&lt; shift);

            //将数组中的指定bit位置一  “&amp; 操作”
            a[arrindex] &amp;= (byte)(bitPos);
        }
        #endregion</code></pre>
<p> </p>
<p>2:Add方法（将bit置1操作）</p>
<p>  同样也很简单，要将当前4对应的bit位置1的话，只需要1左移4位与B[0] | 即可。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzIxNDc0MS8yMDEyMTIwNzE0MzA0MDUwLmpwZw==.jpg"></p>
<pre><code>#region 设置相应bit位上为1
        /// &lt;summary&gt;
        /// 设置相应bit位上为1
        /// &lt;/summary&gt;
        /// &lt;param name="i"&gt;&lt;/param&gt;
        static void Add(byte i)
        {
            //相当于 i%8 的功能
            var shift = i &amp; 0x07;

            //计算应该放数组的下标
            var arrindex = i &gt;&gt; 3;

            //将byte中的 1 移动到i位
            var bitPos = 1 &lt;&lt; shift;

            //将数组中的指定bit位置一  “| 操作”
            a[arrindex] |= (byte)bitPos;
        }
        #endregion</code></pre>
<p> </p>
<p>2:Contain方法（判断当前bit位是否是1）</p>
<p>    如果看懂了Clear和Add，我相信最后一个方法已经不成问题了。</p>
<pre><code>#region 判断当前的x在数组的位中是否存在
        /// &lt;summary&gt;
        ///判断当前的x在数组的位中是否存在
        /// &lt;/summary&gt;
        /// &lt;param name="i"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        static bool Contain(byte i)
        {
            var j = a[i &gt;&gt; 3] &amp; (1 &lt;&lt; (i &amp; 0x07));

            if (j == 0)
                return false;
            return true;
        }
        #endregion</code></pre>
<p>最后上总的代码：
<pre><code>using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Threading;
using System.IO;

namespace ConsoleApplication2
{
    public class Program
    {
        static byte n = 7;

        static byte[] a;

        public static void Main()
        {
            //节省空间的做法
            a = new byte[(n &gt;&gt; 3) + 1];

            for (byte i = 0; i &lt; n; i++)
                Clear(i);

            Add(4);
            Console.WriteLine("插入4成功！");

            var s = Contain(4);

            Console.WriteLine("当前是否包含4:{0}", s);

            s = Contain(5);

            Console.WriteLine("当前是否包含5:{0}", s);

            Console.Read();
        }

        #region 初始化所用的bit位为0
        /// &lt;summary&gt;
        /// 初始化所用的bit位为0
        /// &lt;/summary&gt;
        /// &lt;param name="i"&gt;&lt;/param&gt;
        static void Clear(byte i)
        {
            //相当于 i%8 的功能
            var shift = i &amp; 0x07;

            //计算应该放数组的下标
            var arrindex = i &gt;&gt; 3;

            //则将当前byte中的指定bit位取0，&amp;后其他对方数组bit位必然不变，这就是 1 的妙用
            var bitPos = ~(1 &lt;&lt; shift);

            //将数组中的指定bit位置一  “&amp; 操作”
            a[arrindex] &amp;= (byte)(bitPos);
        }
        #endregion

        #region 设置相应bit位上为1
        /// &lt;summary&gt;
        /// 设置相应bit位上为1
        /// &lt;/summary&gt;
        /// &lt;param name="i"&gt;&lt;/param&gt;
        static void Add(byte i)
        {
            //相当于 i%8 的功能
            var shift = i &amp; 0x07;

            //计算应该放数组的下标
            var arrindex = i &gt;&gt; 3;

            //将byte中的 1 移动到i位
            var bitPos = 1 &lt;&lt; shift;

            //将数组中的指定bit位置一  “| 操作”
            a[arrindex] |= (byte)bitPos;
        }
        #endregion

        #region 判断当前的x在数组的位中是否存在
        /// &lt;summary&gt;
        ///判断当前的x在数组的位中是否存在
        /// &lt;/summary&gt;
        /// &lt;param name="i"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        static bool Contain(byte i)
        {
            var j = a[i &gt;&gt; 3] &amp; (1 &lt;&lt; (i &amp; 0x07));

            if (j == 0)
                return false;
            return true;
        }
        #endregion
    }
}</code></pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzIxNDc0MS8yMDEyMTIwNjEyNTE0ODg4LnBuZw==.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 00:56:47</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>经典算法题每日演练——第十一题 Bitmap算法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWmZxp.html" rel="bookmark">经典算法题每日演练&mdash;&mdash;第二十一题 十字链表</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     上一篇我们看了矩阵的顺序存储,这篇我们再看看一种链式存储方法&quot;十字链表&quot;,当然目的都是一样,压缩空间. 一:概念     既然要用链表节点来模拟矩阵中的非零元素,肯定需要如下5个元素(row,col,val,down,right),其中: row:矩阵中的行. col:矩阵中的列. val:矩阵中的值. right:指向右侧的一个非零元素. down:指向下侧的一个非零元素. 现在我们知道单个节点该如何表示了,那么矩阵中同行的非零元素的表示不就是一个单链表吗?比如如下: 那么			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bam7qQb.html" rel="bookmark">经典算法题每日演练&mdash;&mdash;第七题 KMP算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:经典算法题每日演练--第七题 KMP算法       在大学的时候,应该在数据结构里面都看过kmp算法吧,不知道有多少老师对该算法是一笔带过的,至少我们以前是的, 确实kmp算法还是有点饶人的,如果说红黑树是变态级的,那么kmp算法比红黑树还要变态,很抱歉,每次打kmp的时候,输 入法总是提示&quot;看毛片&quot;三个字,嘿嘿,就叫&quot;看毛片算法&quot;吧. 一:BF算法      如果让你写字符串的模式匹配,你可能会很快的写出朴素的bf算法,至少问题是解决了,我想大家很清楚的知			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z40w4Lz.html" rel="bookmark">经典算法题每日演练&mdash;&mdash;第十七题 Dijkstra算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:经典算法题每日演练--第十七题 Dijkstra算法         或许在生活中,经常会碰到针对某一个问题,在众多的限制条件下,如何去寻找一个最优解?可能大家想到了很多诸如&quot;线性规划&quot;,&quot;动态规划&quot; 这些经典策略,当然有的问题我们可以用贪心来寻求整体最优解,在图论中一个典型的贪心法求最优解的例子就莫过于&quot;最短路径&quot;的问题.   一:概序    从下图中我要寻找V0到V3的最短路径,你会发现通往他们的两点路径有很多:V0-&gt;V4-&g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9x1ndb.html" rel="bookmark">经典算法题每日演练&mdash;&mdash;第二十三题 鸡尾酒排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:经典算法题每日演练--第二十三题 鸡尾酒排序     这篇我们继续扯淡一下鸡尾酒排序,为了知道为啥取名为鸡尾酒,特意看了下百科,见框框的话,也只能勉强这么说了.   要是文艺点的话,可以说是搅拌排序,通俗易懂点的话,就叫&quot;双向冒泡排序&quot;,我想作为码农的话,不可能不知道冒泡排序, 冒泡是一个单向的从小到大或者从大到小的交换排序,而鸡尾酒排序是双向的,从一端进行从小到大排序,从另一端进行从大 到小排序. 从图中可以看到,第一次正向比较,我们找到了最大值9.             			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNn52NM.html" rel="bookmark">经典算法题每日演练&mdash;&mdash;第三题 猴子吃桃</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:经典算法题每日演练--第三题 猴子吃桃           猴子第一天摘下若干个桃子,当即吃了一半,还不过瘾就多吃了一个.第二天早上又将剩下的桃子吃了一半,还是不过瘾又多 吃了一个.以后每天都吃前一天剩下的一半再加一个.到第10天刚好剩一个.问猴子第一天摘了多少个桃子?   分析: 这是一套非常经典的算法题,这个题目体现了算法思想中的递推思想,递归有两种形式,顺推和逆推,针对递推,只要         我们找到递推公式,问题就迎刃而解了.                令S10=1,容易看			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYXdnb.html" rel="bookmark">经典算法题每日演练&mdash;&mdash;第六题 协同推荐SlopeOne 算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:经典算法题每日演练--第六题 协同推荐SlopeOne 算法               相信大家对如下的Category都很熟悉,很多网站都有类似如下的功能,&quot;商品推荐&quot;,&quot;猜你喜欢&quot;,在实体店中我们有导购来为我们服务,在网络上 我们需要同样的一种替代物,如果简简单单的在数据库里面去捞,去比较,几乎是完成不了的,这时我们就需要一种协同推荐算法,来高效的推荐浏览者喜 欢的商品. 一:概念      SlopeOne的思想很简单,就是用均值化的思想来掩盖个体的打			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqWwDGz.html" rel="bookmark">经典算法题每日演练&mdash;&mdash;第八题 AC自动机</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:经典算法题每日演练--第八题 AC自动机        上一篇我们说了单模式匹配算法KMP,现在我们有需求了,我要检查一篇文章中是否有某些敏感词,这其实就是多模式匹配的问题. 当然你也可以用KMP算法求出,那么它的时间复杂度为O(c*(m+n)),c:为模式串的个数.m:为模式串的长度,n:为正文的长度,那 么这个复杂度就不再是线性了,我们学算法就是希望能把要解决的问题优化到极致,这不,AC自动机就派上用场了.    其实AC自动机就是Trie树的一个活用,活用点就是灌输了kmp的思想,从			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqWQ2Zz.html" rel="bookmark">经典算法题每日演练&mdash;&mdash;第十题 树状数组</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:经典算法题每日演练--第十题 树状数组         有一种数据结构是神奇的,神秘的,它展现了位运算与数组结合的神奇魅力,太牛逼的,它就是树状数组,这种数据结构不是神人是发现不了的. 一:概序      假如我现在有个需求,就是要频繁的求数组的前n项和,并且存在着数组中某些数字的频繁修改,那么我们该如何实现这样的需求?当然大家可以往 真实项目上靠一靠. ① 传统方法:根据索引修改为O(1),但是求前n项和为O(n). ②空间换时间方法:我开一个数组sum[],sum[i]=a[1]+..			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bamR2Nb.html" rel="bookmark">经典算法题每日演练&mdash;&mdash;第四题 最长公共子序列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一: 作用        最长公共子序列的问题常用于解决字符串的相似度,是一个非常实用的算法,作为码农,此算法是我们的必备基本功. 二:概念      举个例子,cnblogs这个字符串中子序列有多少个呢?很显然有27个,比如其中的cb,cgs等等都是其子序列,我们可以看出 子序列不见得一定是连续的,连续的那是子串.      我想大家已经了解了子序列的概念,那现在可以延伸到两个字符串了,那么大家能够看出:cnblogs和belong的公共子序列吗? 在你找出的公共子序列中,你能找出最长的公共子			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP8B8p.html" rel="bookmark" class="title">如何监控ORACLE索引使用与否</a>
					<div>
						在数据库管理与维护中,我们总会遇到一个问题:我们创建的索引是否会被某些 SQL语句使用呢?换个通俗表达方式:我创建的索引是否是未使用的索引(unused Indexes),是否有价值呢?如果创建的某个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQOoZp.html" rel="bookmark" class="title">谈谈CNNIC&amp;amp&semi;nbsp&semi;域名投资要慎重</a>
					<div>
						CNNIC,到底是一个国家政府机构,还是一个企业.看不穿. 但是我可以肯定的是CNNIC是一个牛B的炒做专家,和圈钱的地主头. 百度一下域名新闻,N多关于中文域名抢注,然后多少钱出售的,案例,金融周刊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDm90b.html" rel="bookmark" class="title">php中echo &amp;amp&semi;lt&semi;&amp;amp&semi;lt&semi;&amp;amp&semi;lt&semi; 的应用</a>
					<div>
						&lt;?$a=&quot;变量的值将被带入&quot;;echo &lt;&lt;&lt; help&lt;pre&gt;    php中echo &lt;&lt;&lt; 的应用    虽然ech ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp55jAp.html" rel="bookmark" class="title">在ASP&period;net中使用OWC绘制统计图表</a>
					<div>
						asp.net|统计|图表 在使用ASP.net进行Web开发中,经常需要将各种统计数据以图形的方式显示出来.如果仅仅是柱状图,可以采用画表格或者将某种特定颜色的GIF图像缩放宽度和高度的方法来表示, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jjWNb.html" rel="bookmark" class="title">Silverlight控件注册验证机制探索</a>
					<div>
						先给大家介绍一下Silverlight客户端控件的使用情景.一般来说, Silverlight客户端控件会销售给开发Silverlight程序的公司,他们是控件的购 买者.他们开发的程序中会用到Sil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0P5nnM.html" rel="bookmark" class="title">bios不识别硬盘怎么办</a>
					<div>
						  bios不识别硬盘怎么办: 第一种情况最有可能的数据线缆没插好,或者数据线缆有问题.或者是电源的供电问题,硬盘的供电是从电源直接提供的供电接口获得电力的. 白色的是传统的IDE硬盘和光驱的供电接口 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3K85M.html" rel="bookmark" class="title">WPS表格研究：圆和圆的位置关系</a>
					<div>
						  研究几何图形之间的位置关系,几何画板无疑是最佳平台之一,不过巧妙应用WPS表格强大的数据处理与图表生成功能,也可以深入研究一些几何问题?下面笔者就以圆和圆的位置关系 的研究 (如图1)为例,让您对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7EgBb.html" rel="bookmark" class="title">开机自动宽带连接联网方法全教程</a>
					<div>
						方法一.adsl开机自动宽带连接 如果你是adsl进行宽带连接的话,可以在你的ie浏览器上设置自动进行宽带连接.打开你的ie浏览器,然后在点击工具栏上面的&quot;工具-internet选项&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze75exM.html" rel="bookmark" class="title">奔腾的芯：Intel</a>
					<div>
						时势造英雄     在美国西海岸旧金山到圣荷西市(SanJose)之间,围绕着旧金山海湾有几十公里长,几公里宽的峡谷,通常称为硅谷.(在图中绿线圈出来的部分)那里之所以叫硅谷并不是因为它生产硅,而是它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNEdrM.html" rel="bookmark" class="title">mysql-JDBC连接MySQL插入数据问题</a>
					<div>
						问题描述 JDBC连接MySQL插入数据问题 Connection conn = DriverManager.getConnection(&quot;jdbc:mysql://localhost:33 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7Kojz.html" rel="bookmark" class="title">不得不使用的百度快照优化seo技巧</a>
					<div>
						seo就是细节的综合,将各seo优化细节做到位,百度快照优化就成功了一大半.优化百度快照,是有很多技巧的,总结部分,仅供参考. 一 从网站本身来说,百度快照优化譬如说你的网站内容不是很友善,有一点敏锐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3e78z.html" rel="bookmark" class="title">SpringBoot开发案例之整合mail发送服务</a>
					<div>
						上个月做过这样一篇分享笔记,微服务架构实践之邮件通知系统改造. 当时用的是开源的第三方插件mail和Thymeleaf做发送服务,显然这样子你需要配置一些东西,麻烦!!!接触了Spring Boot以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNVgVz.html" rel="bookmark" class="title">参数-VSTO运行出现错误，使word启动后开发项无法运行</a>
					<div>
						问题描述 VSTO运行出现错误,使word启动后开发项无法运行 VSTO运行后,出现如下错误:&quot;SignFile&quot;任务不支持&quot;TargetFrameworkVersion ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NZZLM.html" rel="bookmark" class="title">U15青训首次引入体育大数据 欢呼吧体育助力中国足球数据革命</a>
					<div>
						每届中国足球的国家队或青少队选拔,教练们总会因为具体人选和球队表现等问题产生各种争议.降低经验的权重转向依托体育大数据选拔队员,能给中国足球发展带来突破性改变么? 日前,中国足协 NIKE针对 U15 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA73nXz.html" rel="bookmark" class="title">inux-LINUX 文件夹下误删文件如何恢复</a>
					<div>
						问题描述 LINUX 文件夹下误删文件如何恢复 LINUX 下,TOMCAT ROOT里的内容先全删了.此时叫A1,然后重新上传了ROOT文件夹并解压了,此时是A2,发现弄错了,于是把A2也全删了.但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3Ra8z.html" rel="bookmark" class="title">继承-java中到底为什么要用到抽象类？</a>
					<div>
						问题描述 java中到底为什么要用到抽象类? 比如有个类A,把它设置成abstract是为了不让它实例化,只能表示一个抽象的或者不具体的无法实例化的概念,但是就算不在这个A的前面加abstract照样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0O6VM.html" rel="bookmark" class="title">更新版如何向alexa提交网站简介信息</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 第一步.打开http://www. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkxYrM.html" rel="bookmark" class="title">在循环内部调用递归怎么理解，求解答</a>
					<div>
						问题描述 在循环内部调用递归怎么理解,求解答 private void tree(Set articles,Connection conn,int id,int grade){ String sql= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22kl3b.html" rel="bookmark" class="title">access-VB 到出 Excel 的问题</a>
					<div>
						问题描述 VB 到出 Excel 的问题 1,我个人编写一段东西在工作中用,主要功能就是导出access数据,新建excel文档方便查询,但是目前发现有如下问题,各位大神请帮忙看看: Private  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeAJJM.html" rel="bookmark" class="title">后台&lpar;33&rpar;&mdash;&mdash;注解Annotation</a>
					<div>
						探索Android软键盘的疑难杂症 深入探讨Android异步精髓Handler 详解Android主流框架不可或缺的基石 站在源码的肩膀上全解Scroller工作机制 Android多分辨率适配框架 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPk7JqM.html" rel="bookmark" class="title">5&period;cocos2dx中关于draw绘图，声音和音效，预加载，播放与停止Vs暂停和恢复，音量控制</a>
					<div>
						﻿﻿ 1 draw绘图 头文件 T19Draw.h #ifndef __T19Draw_H__ #define __T19Draw_H__ #include &quot;cocos2d.h&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkARZjb.html" rel="bookmark" class="title">新手指南： 手把手教你安装 Ubuntu 和 Fedora</a>
					<div>
						Linux 由于开源,所以具备可定制性,因此衍生了许多发行版.Ubuntu 和 Fedora 算是其中对新手比较友好的两个发行版,主要是其安装较为简单,用户群多,有问题搜索出相关的信息或者找前辈解决. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2Ea5z.html" rel="bookmark" class="title">为什么有网站网上却还搜不到？</a>
					<div>
						网站托管公司小编前段时间在给企业家讲课,讲关于网站的问题,例如网站更新.网站优化.网站宣传等等问题.当讲到网站在互联网上搜索问题时,一些企业主要负责人问到:现在公司已经建有网站,但是在网络上搜索的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWrwYz.html" rel="bookmark" class="title">Nginx could not build the server&lowbar;names&lowbar;hash 错误的解决办法&lowbar;nginx</a>
					<div>
						在给nginx 配置了一个超长的域名后,通过 /usr/local/nginx/sbin/ngnix -t 检查配置文件时出现一下错误: 复制代码 代码如下: could not build the  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0QYVp.html" rel="bookmark" class="title">准备加入软件开发行业的朋友可以看看</a>
					<div>
						最近新霸哥注意到有一些的朋友想加入到IT行业中,因为现在这个行业比较的火.新手入门该怎么学习,任何一个人都可以学习吗?下面新霸哥将详细的为大家解答. 兴趣是最好的老师 不管是做任何事情,只要你感兴趣就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdv0Y1b.html" rel="bookmark" class="title">捣蛋还是惊喜 互联网万圣吸睛招数盘点</a>
					<div>
						过惯了中规中矩的节日,总算迎来了不一样的捣蛋万圣节.在全民或搞怪或捣蛋的日子里,互联网各行业似乎也纷纷瞄准了这一节日,准备了不少专属于万圣节的惊喜,还能带来不一样的宣传效应.不管是手机浏览器上的万圣节 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2YwyZz.html" rel="bookmark" class="title">Asterisk eSpeak 2&period;0发布 拨号规则应用程序</a>
					<div>
						Asterisk eSpeak提供&quot;eSpeak&quot;拨号规则应用程序,它允许您使用eSpeak语音合成器与Asterisk.这个模块调用本地eSpeak TTS引擎,并用它来呈现文本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA6dJJp.html" rel="bookmark" class="title">Android Auto开发者文档显示UI和第三方应用更多细节</a>
					<div>
						Android Auto开发者文档显示UI和第三方应用更多细节近日谷歌在Android开发者网站公开了关于Android Auto的一系列开发文档,展示谷歌车载平台的诸多细节并赋予了开发者改善系统的特 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YJ0Wp.html" rel="bookmark" class="title">小米4S来袭配置秒杀魅族华为！</a>
					<div>
						小米4S来袭 配置秒杀魅族华为!之前曾有消息称,骁龙810的处理器会在今年3月份量产,这也让人不禁担心,如果小米5一月如果采用它,发布后何时才能开卖.现在有 网友送来了一张小米4S的图,虽然无法证实图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4YnVPb.html" rel="bookmark" class="title">消息流垃圾广告太多 Facebook现在终于动手了</a>
					<div>
						北京时间5月11日消息,照理来说,Facebook动态消息应该显示一些温暖人心的内容,不过点击之后你会发现当中存在大量的垃圾广告,文字很少. 本周三,Facebook宣布,将会对低质量网页的链接进行打 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
